import re
def extract_nginx_name(s):
    match = re.search('(rp_nginx\d+)', s)
    if match:
        result = match.group(1)
    return result

def extract_date(s):
    match = re.search('service/([^/]*)', s)
    if match:
        result = match.group(1)
    return result

def coss_sql(file_path_list):
    oss_sql_list = []
    insert_sql_list = []
    for i,file_path in enumerate(file_path_list):
        f_num = extract_nginx_name(file_path)
        f_date = extract_date(file_path)
        oss_sql = f"""
-- {i}
drop table if exists lebo_data.oss_service_{f_num}_{f_date}_ext;
create external table if not exists lebo_data.oss_service_{f_num}_{f_date}_ext
(
    nginx_log string
)
stored by 'com.aliyun.odps.TsvStorageHandler' 
with serdeproperties (
 'odps.properties.rolearn'='acs:ram::1140215210720917:role/aliyunodpsdefaultrole',
 'odps.text.option.gzip.input.enabled'='true'
) 
location '{file_path}';

drop table if exists lebo_data.src_service_{f_num}_{f_date}_ext;
create table if not exists lebo_data.src_service_{f_num}_{f_date}_ext as
select  0 k_offset,
        now() k_timestamp,
        split(split(rtrim(ltrim(split(nginx_log,'\\\\^\\\\^A')[2],'['),']'),' ')[1],'\\\\?')[0] `uri`,
        'rd.hpplay.cn' host,
        rtrim(ltrim(split(nginx_log,'\\\\^\\\\^A')[0],'['),']') remote_adr,
        rtrim(ltrim(split(nginx_log,'\\\\^\\\\^A')[4],'['),']') agent,
        split(split(rtrim(ltrim(split(nginx_log,'\\\\^\\\\^A')[2],'['),']'),' ')[1],'\\\\?')[1] `args`,
        split(rtrim(ltrim(split(nginx_log,'\\\\^\\\\^A')[2],'['),']'),' ')[0] `action`,
        rtrim(ltrim(split(nginx_log,'\\\\^\\\\^A')[6],'['),']') http_x_forwarded_for,
        rtrim(ltrim(split(nginx_log,'\\\\^\\\\^A')[1],'['),']') localtime,
        '' body,
        rtrim(ltrim(split(nginx_log,'\\\\^\\\\^A')[3],'['),']') `status`,
        if(ISDATE(rtrim(ltrim(split(nginx_log,'\\\\^\\\\^A')[1],'['),']'), 'yyyy/mm/dd hh:mi:ss'),to_char(to_date(rtrim(ltrim(split(nginx_log,'\\\\^\\\\^A')[1],'['),']'),'yyyy/mm/dd hh:mi:ss'),'yyyymmdd'),'20231024') p_date
from    lebo_data.oss_service_{f_num}_{f_date}_ext;
        """

        insert_sql = f"""
select  *
from    lebo_data.src_service_{f_num}_{f_date}_ext
        """

        oss_sql_list.append(oss_sql)
        insert_sql_list.append(insert_sql)
    oss_sql_string = '\n'.join(oss_sql_list)
    insert_sql_string = 'insert into lebo_data.src_service_kafka_oss_ext_temp partition(p_date)' + '\nunion all'.join(insert_sql_list) + ';'
    f = open("D:\workspace_python\my_utils\lebo_utils\mc\oss_data.txt", "w")
    # 将Hello World写入文件中
    f.write(oss_sql_string)
    # 关闭文件对象
    f.close()

    g = open("D:\workspace_python\my_utils\lebo_utils\mc\insert_data.txt", "w")
    # 将Hello World写入文件中
    g.write(insert_sql_string)
    # 关闭文件对象
    g.close()


if __name__ == '__main__':
    file_path_list = ['oss://bigdata-log-report/log/rp_nginx01/service/20230901/', 'oss://bigdata-log-report/log/rp_nginx01/service/20230902/', 'oss://bigdata-log-report/log/rp_nginx01/service/20230903/', 'oss://bigdata-log-report/log/rp_nginx01/service/20230904/', 'oss://bigdata-log-report/log/rp_nginx01/service/20230905/', 'oss://bigdata-log-report/log/rp_nginx01/service/20230906/', 'oss://bigdata-log-report/log/rp_nginx01/service/20230907/', 'oss://bigdata-log-report/log/rp_nginx01/service/20230908/', 'oss://bigdata-log-report/log/rp_nginx01/service/20230909/', 'oss://bigdata-log-report/log/rp_nginx01/service/20230910/', 'oss://bigdata-log-report/log/rp_nginx01/service/20230911/', 'oss://bigdata-log-report/log/rp_nginx01/service/20230912/', 'oss://bigdata-log-report/log/rp_nginx01/service/20230913/', 'oss://bigdata-log-report/log/rp_nginx01/service/20230914/', 'oss://bigdata-log-report/log/rp_nginx01/service/20230915/', 'oss://bigdata-log-report/log/rp_nginx01/service/20230916/', 'oss://bigdata-log-report/log/rp_nginx01/service/20230917/', 'oss://bigdata-log-report/log/rp_nginx01/service/20230918/', 'oss://bigdata-log-report/log/rp_nginx01/service/20230919/', 'oss://bigdata-log-report/log/rp_nginx01/service/20230920/', 'oss://bigdata-log-report/log/rp_nginx01/service/20230921/', 'oss://bigdata-log-report/log/rp_nginx01/service/20230922/', 'oss://bigdata-log-report/log/rp_nginx01/service/20230923/', 'oss://bigdata-log-report/log/rp_nginx01/service/20230924/', 'oss://bigdata-log-report/log/rp_nginx01/service/20230925/', 'oss://bigdata-log-report/log/rp_nginx01/service/20230926/', 'oss://bigdata-log-report/log/rp_nginx01/service/20230927/', 'oss://bigdata-log-report/log/rp_nginx01/service/20230928/', 'oss://bigdata-log-report/log/rp_nginx01/service/20230929/', 'oss://bigdata-log-report/log/rp_nginx01/service/20230930/', 'oss://bigdata-log-report/log/rp_nginx01/service/20231001/', 'oss://bigdata-log-report/log/rp_nginx01/service/20231002/', 'oss://bigdata-log-report/log/rp_nginx01/service/20231003/', 'oss://bigdata-log-report/log/rp_nginx01/service/20231004/', 'oss://bigdata-log-report/log/rp_nginx01/service/20231005/', 'oss://bigdata-log-report/log/rp_nginx01/service/20231006/', 'oss://bigdata-log-report/log/rp_nginx01/service/20231007/', 'oss://bigdata-log-report/log/rp_nginx01/service/20231008/', 'oss://bigdata-log-report/log/rp_nginx02/service/20230901/', 'oss://bigdata-log-report/log/rp_nginx02/service/20230902/', 'oss://bigdata-log-report/log/rp_nginx02/service/20230903/', 'oss://bigdata-log-report/log/rp_nginx02/service/20230904/', 'oss://bigdata-log-report/log/rp_nginx02/service/20230905/', 'oss://bigdata-log-report/log/rp_nginx02/service/20230906/', 'oss://bigdata-log-report/log/rp_nginx02/service/20230907/', 'oss://bigdata-log-report/log/rp_nginx02/service/20230908/', 'oss://bigdata-log-report/log/rp_nginx02/service/20230909/', 'oss://bigdata-log-report/log/rp_nginx02/service/20230910/', 'oss://bigdata-log-report/log/rp_nginx02/service/20230911/', 'oss://bigdata-log-report/log/rp_nginx02/service/20230912/', 'oss://bigdata-log-report/log/rp_nginx02/service/20230913/', 'oss://bigdata-log-report/log/rp_nginx02/service/20230914/', 'oss://bigdata-log-report/log/rp_nginx02/service/20230915/', 'oss://bigdata-log-report/log/rp_nginx02/service/20230916/', 'oss://bigdata-log-report/log/rp_nginx02/service/20230917/', 'oss://bigdata-log-report/log/rp_nginx02/service/20230918/', 'oss://bigdata-log-report/log/rp_nginx02/service/20230919/', 'oss://bigdata-log-report/log/rp_nginx02/service/20230920/', 'oss://bigdata-log-report/log/rp_nginx02/service/20230921/', 'oss://bigdata-log-report/log/rp_nginx02/service/20230922/', 'oss://bigdata-log-report/log/rp_nginx02/service/20230923/', 'oss://bigdata-log-report/log/rp_nginx02/service/20230924/', 'oss://bigdata-log-report/log/rp_nginx02/service/20230925/', 'oss://bigdata-log-report/log/rp_nginx02/service/20230926/', 'oss://bigdata-log-report/log/rp_nginx02/service/20230927/', 'oss://bigdata-log-report/log/rp_nginx02/service/20230928/', 'oss://bigdata-log-report/log/rp_nginx02/service/20230929/', 'oss://bigdata-log-report/log/rp_nginx02/service/20230930/', 'oss://bigdata-log-report/log/rp_nginx02/service/20231001/', 'oss://bigdata-log-report/log/rp_nginx02/service/20231002/', 'oss://bigdata-log-report/log/rp_nginx02/service/20231003/', 'oss://bigdata-log-report/log/rp_nginx02/service/20231004/', 'oss://bigdata-log-report/log/rp_nginx02/service/20231005/', 'oss://bigdata-log-report/log/rp_nginx02/service/20231006/', 'oss://bigdata-log-report/log/rp_nginx02/service/20231007/', 'oss://bigdata-log-report/log/rp_nginx02/service/20231008/', 'oss://bigdata-log-report/log/rp_nginx03/service/20230901/', 'oss://bigdata-log-report/log/rp_nginx03/service/20230902/', 'oss://bigdata-log-report/log/rp_nginx03/service/20230903/', 'oss://bigdata-log-report/log/rp_nginx03/service/20230904/', 'oss://bigdata-log-report/log/rp_nginx03/service/20230905/', 'oss://bigdata-log-report/log/rp_nginx03/service/20230906/', 'oss://bigdata-log-report/log/rp_nginx03/service/20230907/', 'oss://bigdata-log-report/log/rp_nginx03/service/20230908/', 'oss://bigdata-log-report/log/rp_nginx03/service/20230918/', 'oss://bigdata-log-report/log/rp_nginx03/service/20230919/', 'oss://bigdata-log-report/log/rp_nginx03/service/20230920/', 'oss://bigdata-log-report/log/rp_nginx04/service/20230901/', 'oss://bigdata-log-report/log/rp_nginx04/service/20230902/', 'oss://bigdata-log-report/log/rp_nginx04/service/20230903/', 'oss://bigdata-log-report/log/rp_nginx04/service/20230904/', 'oss://bigdata-log-report/log/rp_nginx04/service/20230905/', 'oss://bigdata-log-report/log/rp_nginx04/service/20230906/', 'oss://bigdata-log-report/log/rp_nginx04/service/20230907/', 'oss://bigdata-log-report/log/rp_nginx04/service/20230908/', 'oss://bigdata-log-report/log/rp_nginx04/service/20230909/', 'oss://bigdata-log-report/log/rp_nginx04/service/20230910/', 'oss://bigdata-log-report/log/rp_nginx04/service/20230911/', 'oss://bigdata-log-report/log/rp_nginx04/service/20230912/', 'oss://bigdata-log-report/log/rp_nginx04/service/20230913/', 'oss://bigdata-log-report/log/rp_nginx04/service/20230914/', 'oss://bigdata-log-report/log/rp_nginx04/service/20230915/', 'oss://bigdata-log-report/log/rp_nginx04/service/20230916/', 'oss://bigdata-log-report/log/rp_nginx04/service/20230917/', 'oss://bigdata-log-report/log/rp_nginx04/service/20230918/', 'oss://bigdata-log-report/log/rp_nginx04/service/20230919/', 'oss://bigdata-log-report/log/rp_nginx05/service/20230901/', 'oss://bigdata-log-report/log/rp_nginx05/service/20230902/', 'oss://bigdata-log-report/log/rp_nginx05/service/20230903/', 'oss://bigdata-log-report/log/rp_nginx05/service/20230904/', 'oss://bigdata-log-report/log/rp_nginx05/service/20230905/', 'oss://bigdata-log-report/log/rp_nginx05/service/20230906/', 'oss://bigdata-log-report/log/rp_nginx05/service/20230907/', 'oss://bigdata-log-report/log/rp_nginx05/service/20230908/', 'oss://bigdata-log-report/log/rp_nginx05/service/20230909/', 'oss://bigdata-log-report/log/rp_nginx05/service/20230910/', 'oss://bigdata-log-report/log/rp_nginx05/service/20230911/', 'oss://bigdata-log-report/log/rp_nginx05/service/20230912/', 'oss://bigdata-log-report/log/rp_nginx05/service/20230913/', 'oss://bigdata-log-report/log/rp_nginx05/service/20230914/', 'oss://bigdata-log-report/log/rp_nginx05/service/20230915/', 'oss://bigdata-log-report/log/rp_nginx05/service/20230916/', 'oss://bigdata-log-report/log/rp_nginx05/service/20230917/', 'oss://bigdata-log-report/log/rp_nginx05/service/20230918/', 'oss://bigdata-log-report/log/rp_nginx05/service/20230919/', 'oss://bigdata-log-report/log/rp_nginx05/service/20230920/', 'oss://bigdata-log-report/log/rp_nginx05/service/20230921/', 'oss://bigdata-log-report/log/rp_nginx05/service/20230922/', 'oss://bigdata-log-report/log/rp_nginx05/service/20230923/', 'oss://bigdata-log-report/log/rp_nginx05/service/20230924/', 'oss://bigdata-log-report/log/rp_nginx05/service/20230929/', 'oss://bigdata-log-report/log/rp_nginx05/service/20230930/', 'oss://bigdata-log-report/log/rp_nginx05/service/20231001/', 'oss://bigdata-log-report/log/rp_nginx05/service/20231002/', 'oss://bigdata-log-report/log/rp_nginx06/service/20230901/', 'oss://bigdata-log-report/log/rp_nginx06/service/20230902/', 'oss://bigdata-log-report/log/rp_nginx06/service/20230903/', 'oss://bigdata-log-report/log/rp_nginx06/service/20230904/', 'oss://bigdata-log-report/log/rp_nginx06/service/20230905/', 'oss://bigdata-log-report/log/rp_nginx06/service/20230906/', 'oss://bigdata-log-report/log/rp_nginx06/service/20230907/', 'oss://bigdata-log-report/log/rp_nginx06/service/20230908/', 'oss://bigdata-log-report/log/rp_nginx06/service/20230909/', 'oss://bigdata-log-report/log/rp_nginx06/service/20230910/', 'oss://bigdata-log-report/log/rp_nginx06/service/20230911/', 'oss://bigdata-log-report/log/rp_nginx06/service/20230912/', 'oss://bigdata-log-report/log/rp_nginx06/service/20230913/', 'oss://bigdata-log-report/log/rp_nginx06/service/20230914/', 'oss://bigdata-log-report/log/rp_nginx06/service/20230915/', 'oss://bigdata-log-report/log/rp_nginx06/service/20230916/', 'oss://bigdata-log-report/log/rp_nginx06/service/20230917/', 'oss://bigdata-log-report/log/rp_nginx06/service/20230918/', 'oss://bigdata-log-report/log/rp_nginx06/service/20230919/', 'oss://bigdata-log-report/log/rp_nginx06/service/20230920/', 'oss://bigdata-log-report/log/rp_nginx06/service/20230921/', 'oss://bigdata-log-report/log/rp_nginx06/service/20230922/', 'oss://bigdata-log-report/log/rp_nginx06/service/20230923/', 'oss://bigdata-log-report/log/rp_nginx06/service/20230924/', 'oss://bigdata-log-report/log/rp_nginx06/service/20230925/', 'oss://bigdata-log-report/log/rp_nginx06/service/20230926/', 'oss://bigdata-log-report/log/rp_nginx06/service/20230927/', 'oss://bigdata-log-report/log/rp_nginx06/service/20230928/', 'oss://bigdata-log-report/log/rp_nginx06/service/20230929/', 'oss://bigdata-log-report/log/rp_nginx06/service/20230930/', 'oss://bigdata-log-report/log/rp_nginx06/service/20231001/', 'oss://bigdata-log-report/log/rp_nginx06/service/20231002/', 'oss://bigdata-log-report/log/rp_nginx07/service/20230901/', 'oss://bigdata-log-report/log/rp_nginx07/service/20230902/', 'oss://bigdata-log-report/log/rp_nginx07/service/20230903/', 'oss://bigdata-log-report/log/rp_nginx07/service/20230904/', 'oss://bigdata-log-report/log/rp_nginx07/service/20230905/', 'oss://bigdata-log-report/log/rp_nginx07/service/20230906/', 'oss://bigdata-log-report/log/rp_nginx07/service/20230907/', 'oss://bigdata-log-report/log/rp_nginx07/service/20230908/', 'oss://bigdata-log-report/log/rp_nginx07/service/20230909/', 'oss://bigdata-log-report/log/rp_nginx07/service/20230910/', 'oss://bigdata-log-report/log/rp_nginx07/service/20230911/', 'oss://bigdata-log-report/log/rp_nginx07/service/20230912/', 'oss://bigdata-log-report/log/rp_nginx07/service/20230913/', 'oss://bigdata-log-report/log/rp_nginx07/service/20230914/', 'oss://bigdata-log-report/log/rp_nginx07/service/20230915/', 'oss://bigdata-log-report/log/rp_nginx07/service/20230916/', 'oss://bigdata-log-report/log/rp_nginx07/service/20230917/', 'oss://bigdata-log-report/log/rp_nginx07/service/20230918/', 'oss://bigdata-log-report/log/rp_nginx07/service/20230919/', 'oss://bigdata-log-report/log/rp_nginx07/service/20230920/', 'oss://bigdata-log-report/log/rp_nginx07/service/20230921/', 'oss://bigdata-log-report/log/rp_nginx07/service/20230922/', 'oss://bigdata-log-report/log/rp_nginx07/service/20230923/', 'oss://bigdata-log-report/log/rp_nginx07/service/20230924/', 'oss://bigdata-log-report/log/rp_nginx07/service/20230925/', 'oss://bigdata-log-report/log/rp_nginx07/service/20230926/', 'oss://bigdata-log-report/log/rp_nginx07/service/20230927/', 'oss://bigdata-log-report/log/rp_nginx07/service/20230928/', 'oss://bigdata-log-report/log/rp_nginx07/service/20230929/', 'oss://bigdata-log-report/log/rp_nginx07/service/20230930/', 'oss://bigdata-log-report/log/rp_nginx07/service/20231001/', 'oss://bigdata-log-report/log/rp_nginx07/service/20231002/', 'oss://bigdata-log-report/log/rp_nginx07/service/20231003/', 'oss://bigdata-log-report/log/rp_nginx07/service/20231004/', 'oss://bigdata-log-report/log/rp_nginx07/service/20231005/', 'oss://bigdata-log-report/log/rp_nginx07/service/20231006/', 'oss://bigdata-log-report/log/rp_nginx07/service/20231007/', 'oss://bigdata-log-report/log/rp_nginx07/service/20231008/', 'oss://bigdata-log-report/log/rp_nginx08/service/20230901/', 'oss://bigdata-log-report/log/rp_nginx08/service/20230902/', 'oss://bigdata-log-report/log/rp_nginx08/service/20230903/', 'oss://bigdata-log-report/log/rp_nginx08/service/20230904/', 'oss://bigdata-log-report/log/rp_nginx08/service/20230905/', 'oss://bigdata-log-report/log/rp_nginx08/service/20230906/', 'oss://bigdata-log-report/log/rp_nginx08/service/20230907/', 'oss://bigdata-log-report/log/rp_nginx08/service/20230908/', 'oss://bigdata-log-report/log/rp_nginx08/service/20230909/', 'oss://bigdata-log-report/log/rp_nginx08/service/20230910/', 'oss://bigdata-log-report/log/rp_nginx08/service/20230911/', 'oss://bigdata-log-report/log/rp_nginx08/service/20230912/', 'oss://bigdata-log-report/log/rp_nginx08/service/20230913/', 'oss://bigdata-log-report/log/rp_nginx08/service/20230914/', 'oss://bigdata-log-report/log/rp_nginx08/service/20230915/', 'oss://bigdata-log-report/log/rp_nginx08/service/20230916/', 'oss://bigdata-log-report/log/rp_nginx08/service/20230917/', 'oss://bigdata-log-report/log/rp_nginx08/service/20230918/', 'oss://bigdata-log-report/log/rp_nginx08/service/20230919/', 'oss://bigdata-log-report/log/rp_nginx08/service/20230920/', 'oss://bigdata-log-report/log/rp_nginx08/service/20230921/', 'oss://bigdata-log-report/log/rp_nginx08/service/20230922/', 'oss://bigdata-log-report/log/rp_nginx08/service/20230923/', 'oss://bigdata-log-report/log/rp_nginx08/service/20230924/', 'oss://bigdata-log-report/log/rp_nginx08/service/20230925/', 'oss://bigdata-log-report/log/rp_nginx08/service/20230926/', 'oss://bigdata-log-report/log/rp_nginx08/service/20230927/', 'oss://bigdata-log-report/log/rp_nginx08/service/20230928/', 'oss://bigdata-log-report/log/rp_nginx08/service/20230929/', 'oss://bigdata-log-report/log/rp_nginx08/service/20230930/', 'oss://bigdata-log-report/log/rp_nginx08/service/20231001/', 'oss://bigdata-log-report/log/rp_nginx08/service/20231002/', 'oss://bigdata-log-report/log/rp_nginx08/service/20231003/', 'oss://bigdata-log-report/log/rp_nginx08/service/20231004/', 'oss://bigdata-log-report/log/rp_nginx08/service/20231005/', 'oss://bigdata-log-report/log/rp_nginx08/service/20231006/', 'oss://bigdata-log-report/log/rp_nginx08/service/20231007/', 'oss://bigdata-log-report/log/rp_nginx08/service/20231008/', 'oss://bigdata-log-report/log/rp_nginx09/service/20230901/', 'oss://bigdata-log-report/log/rp_nginx09/service/20230902/', 'oss://bigdata-log-report/log/rp_nginx09/service/20230903/', 'oss://bigdata-log-report/log/rp_nginx09/service/20230904/', 'oss://bigdata-log-report/log/rp_nginx09/service/20230905/', 'oss://bigdata-log-report/log/rp_nginx09/service/20230906/', 'oss://bigdata-log-report/log/rp_nginx09/service/20230907/', 'oss://bigdata-log-report/log/rp_nginx09/service/20230908/', 'oss://bigdata-log-report/log/rp_nginx09/service/20230909/', 'oss://bigdata-log-report/log/rp_nginx09/service/20230910/', 'oss://bigdata-log-report/log/rp_nginx09/service/20230911/', 'oss://bigdata-log-report/log/rp_nginx09/service/20230912/', 'oss://bigdata-log-report/log/rp_nginx09/service/20230913/', 'oss://bigdata-log-report/log/rp_nginx09/service/20230914/', 'oss://bigdata-log-report/log/rp_nginx09/service/20230915/', 'oss://bigdata-log-report/log/rp_nginx09/service/20230916/', 'oss://bigdata-log-report/log/rp_nginx09/service/20230917/', 'oss://bigdata-log-report/log/rp_nginx09/service/20230918/', 'oss://bigdata-log-report/log/rp_nginx09/service/20230919/', 'oss://bigdata-log-report/log/rp_nginx09/service/20230920/', 'oss://bigdata-log-report/log/rp_nginx09/service/20230921/', 'oss://bigdata-log-report/log/rp_nginx09/service/20230922/', 'oss://bigdata-log-report/log/rp_nginx09/service/20230923/', 'oss://bigdata-log-report/log/rp_nginx09/service/20230924/', 'oss://bigdata-log-report/log/rp_nginx09/service/20230925/', 'oss://bigdata-log-report/log/rp_nginx09/service/20230926/', 'oss://bigdata-log-report/log/rp_nginx09/service/20230927/', 'oss://bigdata-log-report/log/rp_nginx09/service/20230928/', 'oss://bigdata-log-report/log/rp_nginx09/service/20230929/', 'oss://bigdata-log-report/log/rp_nginx09/service/20230930/', 'oss://bigdata-log-report/log/rp_nginx09/service/20231001/', 'oss://bigdata-log-report/log/rp_nginx09/service/20231002/', 'oss://bigdata-log-report/log/rp_nginx09/service/20231003/', 'oss://bigdata-log-report/log/rp_nginx09/service/20231004/', 'oss://bigdata-log-report/log/rp_nginx09/service/20231005/', 'oss://bigdata-log-report/log/rp_nginx09/service/20231006/', 'oss://bigdata-log-report/log/rp_nginx09/service/20231007/', 'oss://bigdata-log-report/log/rp_nginx09/service/20231008/', 'oss://bigdata-log-report/log/rp_nginx10/service/20230901/', 'oss://bigdata-log-report/log/rp_nginx10/service/20230902/', 'oss://bigdata-log-report/log/rp_nginx10/service/20230903/', 'oss://bigdata-log-report/log/rp_nginx10/service/20230904/', 'oss://bigdata-log-report/log/rp_nginx10/service/20230905/', 'oss://bigdata-log-report/log/rp_nginx10/service/20230906/', 'oss://bigdata-log-report/log/rp_nginx10/service/20230907/', 'oss://bigdata-log-report/log/rp_nginx10/service/20230908/', 'oss://bigdata-log-report/log/rp_nginx10/service/20230909/', 'oss://bigdata-log-report/log/rp_nginx10/service/20230910/', 'oss://bigdata-log-report/log/rp_nginx10/service/20230911/', 'oss://bigdata-log-report/log/rp_nginx10/service/20230912/', 'oss://bigdata-log-report/log/rp_nginx10/service/20230913/', 'oss://bigdata-log-report/log/rp_nginx10/service/20230914/', 'oss://bigdata-log-report/log/rp_nginx10/service/20230915/', 'oss://bigdata-log-report/log/rp_nginx10/service/20230916/', 'oss://bigdata-log-report/log/rp_nginx10/service/20230917/', 'oss://bigdata-log-report/log/rp_nginx10/service/20230918/', 'oss://bigdata-log-report/log/rp_nginx10/service/20230919/', 'oss://bigdata-log-report/log/rp_nginx10/service/20230920/', 'oss://bigdata-log-report/log/rp_nginx10/service/20230921/', 'oss://bigdata-log-report/log/rp_nginx10/service/20230922/', 'oss://bigdata-log-report/log/rp_nginx10/service/20230923/', 'oss://bigdata-log-report/log/rp_nginx10/service/20230924/', 'oss://bigdata-log-report/log/rp_nginx10/service/20230925/', 'oss://bigdata-log-report/log/rp_nginx10/service/20230926/', 'oss://bigdata-log-report/log/rp_nginx10/service/20230927/', 'oss://bigdata-log-report/log/rp_nginx10/service/20230928/', 'oss://bigdata-log-report/log/rp_nginx10/service/20230929/', 'oss://bigdata-log-report/log/rp_nginx10/service/20230930/', 'oss://bigdata-log-report/log/rp_nginx10/service/20231001/', 'oss://bigdata-log-report/log/rp_nginx10/service/20231002/', 'oss://bigdata-log-report/log/rp_nginx10/service/20231003/', 'oss://bigdata-log-report/log/rp_nginx10/service/20231004/', 'oss://bigdata-log-report/log/rp_nginx10/service/20231005/', 'oss://bigdata-log-report/log/rp_nginx10/service/20231006/', 'oss://bigdata-log-report/log/rp_nginx10/service/20231007/', 'oss://bigdata-log-report/log/rp_nginx10/service/20231008/', 'oss://bigdata-log-report/log/rp_nginx11/service/20230901/', 'oss://bigdata-log-report/log/rp_nginx11/service/20230902/', 'oss://bigdata-log-report/log/rp_nginx11/service/20230903/', 'oss://bigdata-log-report/log/rp_nginx11/service/20230904/', 'oss://bigdata-log-report/log/rp_nginx11/service/20230905/', 'oss://bigdata-log-report/log/rp_nginx11/service/20230906/', 'oss://bigdata-log-report/log/rp_nginx11/service/20230907/', 'oss://bigdata-log-report/log/rp_nginx11/service/20230908/', 'oss://bigdata-log-report/log/rp_nginx11/service/20230909/', 'oss://bigdata-log-report/log/rp_nginx11/service/20230910/', 'oss://bigdata-log-report/log/rp_nginx11/service/20230911/', 'oss://bigdata-log-report/log/rp_nginx11/service/20230912/', 'oss://bigdata-log-report/log/rp_nginx11/service/20230913/', 'oss://bigdata-log-report/log/rp_nginx11/service/20230914/', 'oss://bigdata-log-report/log/rp_nginx11/service/20230915/', 'oss://bigdata-log-report/log/rp_nginx11/service/20230916/', 'oss://bigdata-log-report/log/rp_nginx11/service/20230917/', 'oss://bigdata-log-report/log/rp_nginx11/service/20230918/', 'oss://bigdata-log-report/log/rp_nginx11/service/20230919/', 'oss://bigdata-log-report/log/rp_nginx11/service/20230920/', 'oss://bigdata-log-report/log/rp_nginx11/service/20230921/', 'oss://bigdata-log-report/log/rp_nginx11/service/20230922/', 'oss://bigdata-log-report/log/rp_nginx11/service/20230923/', 'oss://bigdata-log-report/log/rp_nginx11/service/20230924/', 'oss://bigdata-log-report/log/rp_nginx11/service/20230925/', 'oss://bigdata-log-report/log/rp_nginx11/service/20230926/', 'oss://bigdata-log-report/log/rp_nginx11/service/20230927/', 'oss://bigdata-log-report/log/rp_nginx11/service/20230928/', 'oss://bigdata-log-report/log/rp_nginx11/service/20230929/', 'oss://bigdata-log-report/log/rp_nginx11/service/20230930/', 'oss://bigdata-log-report/log/rp_nginx11/service/20231001/', 'oss://bigdata-log-report/log/rp_nginx11/service/20231002/', 'oss://bigdata-log-report/log/rp_nginx11/service/20231003/', 'oss://bigdata-log-report/log/rp_nginx11/service/20231004/', 'oss://bigdata-log-report/log/rp_nginx11/service/20231005/', 'oss://bigdata-log-report/log/rp_nginx11/service/20231006/', 'oss://bigdata-log-report/log/rp_nginx11/service/20231007/', 'oss://bigdata-log-report/log/rp_nginx11/service/20231008/', 'oss://bigdata-log-report/log/rp_nginx12/service/20230901/', 'oss://bigdata-log-report/log/rp_nginx12/service/20230902/', 'oss://bigdata-log-report/log/rp_nginx12/service/20230903/', 'oss://bigdata-log-report/log/rp_nginx12/service/20230904/', 'oss://bigdata-log-report/log/rp_nginx12/service/20230905/', 'oss://bigdata-log-report/log/rp_nginx12/service/20230906/', 'oss://bigdata-log-report/log/rp_nginx12/service/20230907/', 'oss://bigdata-log-report/log/rp_nginx12/service/20230908/', 'oss://bigdata-log-report/log/rp_nginx12/service/20230909/', 'oss://bigdata-log-report/log/rp_nginx12/service/20230910/', 'oss://bigdata-log-report/log/rp_nginx12/service/20230911/', 'oss://bigdata-log-report/log/rp_nginx12/service/20230912/', 'oss://bigdata-log-report/log/rp_nginx12/service/20230913/', 'oss://bigdata-log-report/log/rp_nginx12/service/20230914/', 'oss://bigdata-log-report/log/rp_nginx12/service/20230915/', 'oss://bigdata-log-report/log/rp_nginx12/service/20230916/', 'oss://bigdata-log-report/log/rp_nginx12/service/20230917/', 'oss://bigdata-log-report/log/rp_nginx12/service/20230918/', 'oss://bigdata-log-report/log/rp_nginx12/service/20230919/', 'oss://bigdata-log-report/log/rp_nginx12/service/20230920/', 'oss://bigdata-log-report/log/rp_nginx12/service/20230921/', 'oss://bigdata-log-report/log/rp_nginx12/service/20230922/', 'oss://bigdata-log-report/log/rp_nginx12/service/20230923/', 'oss://bigdata-log-report/log/rp_nginx12/service/20230924/', 'oss://bigdata-log-report/log/rp_nginx12/service/20230925/', 'oss://bigdata-log-report/log/rp_nginx12/service/20230926/', 'oss://bigdata-log-report/log/rp_nginx12/service/20230927/', 'oss://bigdata-log-report/log/rp_nginx12/service/20230928/', 'oss://bigdata-log-report/log/rp_nginx12/service/20230929/', 'oss://bigdata-log-report/log/rp_nginx12/service/20230930/', 'oss://bigdata-log-report/log/rp_nginx12/service/20231001/', 'oss://bigdata-log-report/log/rp_nginx12/service/20231002/', 'oss://bigdata-log-report/log/rp_nginx12/service/20231003/', 'oss://bigdata-log-report/log/rp_nginx12/service/20231004/', 'oss://bigdata-log-report/log/rp_nginx12/service/20231005/', 'oss://bigdata-log-report/log/rp_nginx12/service/20231006/', 'oss://bigdata-log-report/log/rp_nginx12/service/20231007/', 'oss://bigdata-log-report/log/rp_nginx12/service/20231008/']
    date_list = []
    for i in file_path_list:
        if extract_date(i) in range(20230911,20230920):
            date_list.append(i)
    print(date_list)
    # coss_sql(date_list)
    